/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignClone type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignClone{}

// CampaignClone struct for CampaignClone
type CampaignClone struct {
	TargetChannels []CampaignCloneTargetChannelsInner `json:"target_channels"`
	OrganizationId string `json:"organization_id"`
}

// NewCampaignClone instantiates a new CampaignClone object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignClone(targetChannels []CampaignCloneTargetChannelsInner, organizationId string) *CampaignClone {
	this := CampaignClone{}
	this.TargetChannels = targetChannels
	this.OrganizationId = organizationId
	return &this
}

// NewCampaignCloneWithDefaults instantiates a new CampaignClone object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignCloneWithDefaults() *CampaignClone {
	this := CampaignClone{}
	return &this
}

// GetTargetChannels returns the TargetChannels field value
func (o *CampaignClone) GetTargetChannels() []CampaignCloneTargetChannelsInner {
	if o == nil {
		var ret []CampaignCloneTargetChannelsInner
		return ret
	}

	return o.TargetChannels
}

// GetTargetChannelsOk returns a tuple with the TargetChannels field value
// and a boolean to check if the value has been set.
func (o *CampaignClone) GetTargetChannelsOk() ([]CampaignCloneTargetChannelsInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetChannels, true
}

// SetTargetChannels sets field value
func (o *CampaignClone) SetTargetChannels(v []CampaignCloneTargetChannelsInner) {
	o.TargetChannels = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *CampaignClone) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *CampaignClone) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *CampaignClone) SetOrganizationId(v string) {
	o.OrganizationId = v
}

func (o CampaignClone) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignClone) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["target_channels"] = o.TargetChannels
	toSerialize["organization_id"] = o.OrganizationId
	return toSerialize, nil
}

type NullableCampaignClone struct {
	value *CampaignClone
	isSet bool
}

func (v NullableCampaignClone) Get() *CampaignClone {
	return v.value
}

func (v *NullableCampaignClone) Set(val *CampaignClone) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignClone) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignClone) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignClone(val *CampaignClone) *NullableCampaignClone {
	return &NullableCampaignClone{value: val, isSet: true}
}

func (v NullableCampaignClone) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignClone) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


